import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class PathInfoTest extends HttpServlet implements SingleThreadModel {

  static final String jspName = "/pathinfobug/pathinfobug.jsp";
  static final String servletPath = "./servlet";

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    tell("INIT");
  }

  public void service(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

  try {
    String message = request.getPathInfo();
    if (message==null) message = request.getParameter("msg");
    if (message!=null) message = message.toLowerCase();

    tell(message);

    if (message!=null) request.setAttribute("message", new String(message));
    request.setAttribute("servlet", new String(servletPath));

    getServletContext()
      .getRequestDispatcher(jspName)
      .forward(request, response);
  }
  catch (Exception e) {
    System.out.println("-----ERROR-----");
    e.printStackTrace(System.out);
    }
  }

  public String getServletInfo() {
    return "demonstrates .forward() with and without a .getPathInfo()==null";
  }

  private void tell(String msg) {
    System.out.println("*** PathInfoTest: " + msg);
  }
}
